var curFocus;
var map = new Array(1);
var bFlag = false;
var initialElement = null;
var scrollSize = 420;
var index;
var bodyList = document.getElementsByTagName("body");
var body = bodyList[0];
// insert initTabbing(); into the onload handler for the <body> tag
var str = body.getAttribute("onload");
str = str+"; initTabbing();";
body.setAttribute("onload",str);
self.oldkeydown=self.onkeydown;
self.onkeydown=tabbedKeyDown;
self.onblur="curFocus.focus();";

//body.setAttribute("scroll","no");
//window.scrollbars = false;

// Map all the elements of a given tag type and add to the list of tracked elements
function mapHTMLElementsByTagName(tag) {
  var nodeList = document.getElementsByTagName(tag);
  var node;
  for (i=0; i <  nodeList.length; i++) {
     node = nodeList.item(i);
     if (node) {
        // test to see if the node should be added
        bAdd = false;
        switch (tag) {
	     case "A": 
              if (node.href) bAdd = true;
		    break;
	     case "INPUT":
		    if (node.type != "hidden" && node.type != "HIDDEN") 
		 	  bAdd = true; 
		    break;
	     case "AREA":
		    bAdd = true;
		    break;
	     case "BUTTON":
		    bAdd = true;
		    break;
	     case "SELECT":
		    bAdd = true;
		    break;
	     case "TEXTAREA":
		    bAdd = true;
		    break;
	  }
        if (bAdd) {
             map[index] = node;
             index++;
        }
     }
  }
}


// map all selectable items in an HTML page
function mapActiveHTMLElements() {
   var doc;
  
   // baseline the counter for number of items we care about
   index = 0;

   // map the specific elements which can get focus
   mapHTMLElementsByTagName("A");
   mapHTMLElementsByTagName("INPUT");
//   mapHTMLElementsByTagName("AREA");  // cannot handle because cannot Mozilla doesn't seem to allow AREAs to get the focus
   mapHTMLElementsByTagName("BUTTON");
//   mapHTMLElementsByTagName("SELECT");  // cannot handle because arrow keys are required to navigate between controls, not values within a control.
   mapHTMLElementsByTagName("TEXTAREA");
}

// In Mozilla, if an object has a visibility style property, it overrides any container
// However, if no visiblity property is specified, it inherits properties from the container.
function IsVisible(obj) 
{
	if (obj) 
	{
		var bRet = (obj.style.visibility != "hidden");

		if (bRet) 
		{
			var temp = obj.offsetParent;
			while (temp) 
			{
				if (temp.style && temp.style.visibility == "hidden") 
				{
					bRet = false;
					break;
				}
				temp = temp.offsetParent;
			}
		}
	}

	return bRet;
}

function exitTabbing() {
   // run any existing onload function
   // if (window._content.document.body.oldunload) window._content.document.body.oldunload();
}

// Initialize the system to utilize tabbing features
function initTabbing() 
{
	var i;
	index = 0;
 	InitSet = false;
	map = new Array(0);

	if(curFocus)
		UnHiliteElement(curFocus);

	// create an array of all selectable elements on the page
	mapActiveHTMLElements();
	// for each element in the list, intercept the key, focus, and mouse events
	// move backwards through list so that we can find the first visible element
	for (i=0; i < map.length; i++) 
	{
		// find the center point of the element and store in another location so that we 

		// can access it when finding the closest element to this item.  This works because
		// we are storing a complete snapshot of the RELATIVE locations of the items, and 
		// not the absolute position
		SetCenterPoint(map[i]);

		map[i].relativeX = map[i].centerX;	  
		map[i].relativeY = map[i].centerY;
// This does not seem to be needed by Mozilla
//		map[i].scrollY = Math.floor((map[i].centerY / scrollSize)) * scrollSize;

		// figure out which is the first visible element in the list & store it
		if( InitSet == false )
		{
			if( IsVisible(map[i]) )
			{
                        // if the element has an "initial = yes" attribute, then use an initial element
				if (map[i].hasAttribute("initial") && map[i].getAttribute("initial")=="yes") 
				{
					initialElement = map[i];
					InitSet = true;
				}
				else 
				{
                              // find the top most (left secondary attribute) element as default
			            if (initialElement == null) {
					    initialElement = map[i];             
			            } else {
			                if (map[i].centerY < initialElement.centerY) initialElement = map[i];
                                  if (map[i].centerX < initialElement.centerX) initialElement = map[i]; 
			            }
				}
			}	
		}	
	}	

   // init the first element
   HiliteElement(initialElement);
}


function HiliteElement(obj) {
   if (!obj) return;
   UnHiliteElement(curFocus);
   curFocus = obj;
   obj.focus();
}

function UnHiliteElement(obj) {
   if (!obj) return;
   obj.blur();
}

function moveKeyPress(key) {
   var bTest = false;
   var newNode;
   if (curFocus) {
     switch (key) {
        case 37: // left
          newNode = GetClosestElement(curFocus, "left");
	    break;
        case 38: // up
          newNode = GetClosestElement(curFocus, "up");
	    break;
        case 39:  // right
          newNode = GetClosestElement(curFocus, "right");
	    break;
        case 40:  // down
          newNode = GetClosestElement(curFocus, "down");
	    break;
     }
     // give new element focus & move cursor over it
     if (newNode && newNode != curFocus) {
        bTest = true;
        HiliteElement(newNode);
// This does not seem to be needed by Mozilla
        // test to see if we need to scroll
//        bScroll = (newNode.scrollY != curFocus.scrollY);
        // make sure node is in view (takes care of scrolling)
//        if (bScroll) {
//	       Window.scrollTo(0,newNode.scrollY-20);
//        }
     }
   }
   return bTest;
}

function call_oldkeydown(ev) {
   // call any previous keydown handler
   if (self.oldkeydown) {
      self.oldkeydown(ev);
      curFocus.focus();
   }
}

function tabbedKeyDown(ev) {
   // remote control codes
   switch (ev.keyCode) {
      case 37: 
	    moveKeyPress(ev.keyCode);
          bFlag = true;
          break;
	  case 38:
	    moveKeyPress(ev.keyCode);
          bFlag = true;
	    break;
	  case 39:
	    moveKeyPress(ev.keyCode);
          bFlag = true;
	    break;
	  case 40:
	    moveKeyPress(ev.keyCode);
          bFlag = true;
	    break;
	  case 69:
          if (curFocus && curFocus.onclick){
             curFocus.onclick();
          } 
          break;
        default:
          call_oldkeydown(ev);
   }

}


// set variables centerX and centerY for an object (screen coordinates)
function SetCenterPoint(obj) {
   if (obj) {
      // move the mouse cursor to be centered in the new element
      x = obj.offsetLeft + (obj.offsetWidth/2);
      y = obj.offsetTop + (obj.offsetHeight/2);
      par = obj;
      while (par.offsetParent) {
         par = par.offsetParent;
   	     x = x + par.offsetLeft;
	     y = y + par.offsetTop;
//   	     x = x + par.offsetLeft - par.scrollLeft;
//	     y = y + par.offsetTop - par.scrollTop;
      }
      obj.centerX = x;
      obj.centerY = y;
   }
}

// get the distance from obj1 to obj2
function GetDistance(obj1, obj2) {
  var retDist, a2, b2;

  retDist = -1;
  if (obj1 && obj2) {
// this would be needed if we assumed that items were moving around after onload()
//     SetCenterPoint(obj1);
//     SetCenterPoint(obj2);
     a2 = Math.pow((obj1.centerX - obj2.centerX),2);
     b2 = Math.pow((obj1.centerY - obj2.centerY),2);

     retDist = Math.sqrt(a2 + b2);
  }

  return retDist; 
}


// Use when layers are hidden & a new control needs to be hilited
// algorithm:  find closest visible element & hilite it
function HiliteClosestElement() {
   var closeDist, closeNode, i, testObj, bTest, dist1;
   if (curFocus) {
      closeDist = 10000;
      closeNode = curFocus;
      // for each element in the movement map, find the closest one
      for (i=0; i < map.length; i++) {
         testObj = map[i];
   	     // only allow selection of visible items
	     bTest = IsVisible(testObj);
	     // element qualifies as a possible target
	     if (bTest) {
	        // compare distance & find element closest to obj
  	  	    if (closeNode) {
			   dist1 = GetDistance(curFocus,testObj);
  			   if (dist1 < closeDist) {
			      closeNode = testObj;
  			      closeDist = dist1;
			   }
		    } else {
			   closeNode = testObj;
			   closeDist = GetDistance(obj, closeNode);
			}
		 }
      }
      // if we have a new element, then move hilite
      if (closeNode != curFocus) {
         HiliteElement(closeNode); 
      }   
   }
}

// Test to see if the two objects bounds overlap or are inclusive/encompassing of each other 
function IsOverlap(testObj, obj, axis) {
   var bTest = false;
   var oWidth, oHeight, tHeight, tWidth;
   var t1, t2;

   oWidth = obj.offsetWidth/2;
   oHeight = obj.offsetHeight/2;
   tWidth = testObj.offsetWidth/2;
   tHeight = testObj.offsetHeight/2;
   // test to see if the boundaries overlap (at leat 5 pixel overlap)
   switch (axis) {
      case "Y":
         bTest = ((testObj.relativeY+tHeight-5) > (obj.relativeY - oHeight)) &&
                 ((testObj.relativeY-tHeight+5) < (obj.relativeY + oHeight));
         break;
      case "X":
         bTest = ((testObj.relativeX+tWidth-5) > (obj.relativeX - oWidth)) &&
                 ((testObj.relativeX-tWidth+5) < (obj.relativeX + oWidth));
         break;
   }
   // if true, go ahead and return
   if (bTest) {
     return bTest;
   }

   // otherwise, continue testing
   // test to see if the testObj boundaries are totally included within obj
   switch (axis) {
      case "Y":
         bTest = ((testObj.relativeY+tHeight) < (obj.relativeY + oHeight)) &&
                 ((testObj.relativeY-tHeight) > (obj.relativeY - oHeight));
         break;
      case "X":
         bTest = ((testObj.relativeX+tWidth) < (obj.relativeX + oWidth)) &&
                 ((testObj.relativeX-tWidth) > (obj.relativeX - oWidth));
         break;
   }
   // if true, go ahead and return
   if (bTest) {
     return bTest;
   }


   // otherwise, continue testing
   // test to see if the testObj boundaries totally encompass obj
   switch (axis) {
      case "Y":
         bTest = ((testObj.relativeY+tHeight) > (obj.relativeY + oHeight)) &&
                 ((testObj.relativeY-tHeight) < (obj.relativeY - oHeight));
         break;
      case "X":
         bTest = ((testObj.relativeX+tWidth) > (obj.relativeX + oWidth)) &&
                 ((testObj.relativeX-tWidth) < (obj.relativeX - oWidth));
         break;
   }

   return bTest
}


// Test to see if the <testObj> position is to the <direction> of the <obj>
function TestDirection(testObj, obj, direction) {
   var bTest = false;
   var oWidth, oHeight;

   oWidth = obj.offsetWidth/2;
   oHeight = obj.offsetHeight/2;

   switch (direction) {
      case "left":
         bTest = (testObj.relativeX < (obj.relativeX - oWidth));
         break;
      case "right":
         bTest = (testObj.relativeX > (obj.relativeX + oWidth));
         break;
      case "up":
         bTest = (testObj.relativeY < (obj.relativeY - oHeight));
         break;
      case "down":
         bTest = (testObj.relativeY > (obj.relativeY + oHeight));
         break;
   }
   return bTest;
}


// get element which is closest in the given direction
// algorithm:  increase weighting for distance from midline
// this is much more efficient, but occasionally makes mistakes due to layout of objects
function GetClosestElement(obj, direction) {
   var dist, closeNode, closeNode1, closeNode2, testObj, bTest;
   var dist1, dist2, dist3;
   var dx, dy;
   dist = 100000000;
   closeNode = curFocus;

   if (curFocus && obj) {
	  // for each element in the movement map, see if the object lays in the right direction.
	  // if so, then find the closest one and move to it.
      for (i=0; i < map.length; i++) {
   	  bTest = false; 
        testObj = map[i];
        dx = obj.relativeX - testObj.relativeX;
        dy = obj.relativeY - testObj.relativeY;
        // test if item lays beyond the current control in a given direction
        switch (direction) {
	      case "left":
               bTest = TestDirection(testObj, obj, "left");
      	   // give extra weight as point leaves the midline
  		   dy = dy*dy; 
               // if testObj overlaps bounds of obj, then treat specially
               if (bTest && IsOverlap(testObj, obj, "Y")) dy = 0;
	         break;
          case "right":
               bTest = TestDirection(testObj, obj, "right");
		   dy = dy*dy; 
               if (bTest && IsOverlap(testObj, obj, "Y"))  dy = 0;
	         break;
	      case "up":
               bTest = TestDirection(testObj, obj, "up");
		   dx = dx*dx;
               if (bTest && IsOverlap(testObj, obj, "X"))  dx = 0;
	         break;
	      case "down":
               bTest = TestDirection(testObj, obj, "down");
		   dx = dx*dx;
               if (bTest && IsOverlap(testObj, obj, "X")) dx = 0;
	         break;
        }
        // only allow selection of visible items
        if (IsVisible(testObj) == false) bTest = false;

        // element qualifies as a possible target
        if (bTest) {
           // compare distance & find element closest to obj
	      dist1 = Math.sqrt((dx*dx)+(dy*dy));
	      if (dist1 < dist) {
               // if the 
	         closeNode = testObj;
	         dist = dist1;
	      } else if (dist1 == dist) {
               // if distances are the same, then take the left-most object
               if (dist1.offsetLeft < dist.offsetLeft) {
	            closeNode = testObj;
  	            dist = dist1;
               }
            }
        }
      }
   }
   return closeNode;
}


